#include<iostream>
#include<fstream>
#include<string>

using std::cin;
using std::cout;
using std::endl;
using std::ofstream;
using std::ifstream;
using std::string;


bool fileExists(string fileName)
{
    bool result = true;

    //ifstream fin;
    //fin.open(fileName, std::ios_base::_Nocreate)
    ifstream fin(fileName, std::ios_base::_Nocreate);
    if (fin.fail())
    {
        result = false;
    }
    fin.close();
    return result;
}

void copyFile(string inputFileName, string outputFileName)
{
    if (inputFileName != outputFileName    )
    {
        ifstream fin(inputFileName);
        ofstream fout(outputFileName);

        string line;
        //eof - end of file
        while (!fin.eof())
        {
            getline(fin, line);
            fout << line << endl;
        }
    fin.close();
    fout.close();
    }
}
        




void main()
{
    //get the name of the file to read from
    string inputFileName;
    cout << "File to read? ";
    getline(cin, inputFileName);
    

    //try to open the file to read 
    if (fileExists(inputFileName))
    {
        //get the name of the file to write to
        string outputFileName;
        cout << "File to write? ";
        getline(cin, outputFileName);

        bool performTheCopy = true;
        if (fileExists(outputFileName))
        {
            performTheCopy = false;
            cout << outputFileName << " already exists." << endl;
            cout << "Overwrite (Y/N)?";
            char overwrite;
            cin >> overwrite;
            if (overwrite == 'Y' || overwrite == 'y')
            {
                performTheCopy = true;
            }
        }
        if (performTheCopy)
        {
            cout << "Copying file ... " << endl;
            copyFile(inputFileName, outputFileName);
        }
    }
    else
    {
        //if it is not there, show an error message
        cout << "File not found " << endl;
    }
    

    //try to open the file to write to
    //do NOT overwrite an existing file until you ask the user if it is ok

}